From CHRIS.A.CONGER@saic.com Fri May 20 10:02:00 2005
Message-Id: <E60A4A796B63D51187670002A5750656CCEECD@us-albuquerque.mail.saic.com>
From: "Conger, Chris A." <CHRIS.A.CONGER@saic.com>
To: 'Greg KH' <greg@kroah.com>
Subject: USB: fix Bug in usb-skeleton.c
Date: Fri, 20 May 2005 09:44:53 -0700


Compare endpoint address to USB_ENDPOINT_DIR_MASK to determine endpoint
direction...


From: "Conger, Chris A." <CHRIS.A.CONGER@saic.com>
Signed-off-by: Greg Kroah-Hartman <gregkh@suse.de>

---
 drivers/usb/usb-skeleton.c |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

--- gregkh-2.6.orig/drivers/usb/usb-skeleton.c	2005-07-27 22:51:14.000000000 -0700
+++ gregkh-2.6/drivers/usb/usb-skeleton.c	2005-07-27 22:51:15.000000000 -0700
@@ -257,7 +257,8 @@
 		endpoint = &iface_desc->endpoint[i].desc;
 
 		if (!dev->bulk_in_endpointAddr &&
-		    (endpoint->bEndpointAddress & USB_DIR_IN) &&
+		    ((endpoint->bEndpointAddress & USB_ENDPOINT_DIR_MASK)
+					== USB_DIR_IN) &&
 		    ((endpoint->bmAttributes & USB_ENDPOINT_XFERTYPE_MASK)
 					== USB_ENDPOINT_XFER_BULK)) {
 			/* we found a bulk in endpoint */
@@ -272,7 +273,8 @@
 		}
 
 		if (!dev->bulk_out_endpointAddr &&
-		    !(endpoint->bEndpointAddress & USB_DIR_OUT) &&
+		    ((endpoint->bEndpointAddress & USB_ENDPOINT_DIR_MASK)
+					== USB_DIR_OUT) &&
 		    ((endpoint->bmAttributes & USB_ENDPOINT_XFERTYPE_MASK)
 					== USB_ENDPOINT_XFER_BULK)) {
 			/* we found a bulk out endpoint */
